VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "vbGL Ejemplo 7 (Cg Normal & Gloss Map)"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   213
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Pict 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   750
      Left            =   240
      ScaleHeight     =   50
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   56
      TabIndex        =   0
      Top             =   510
      Visible         =   0   'False
      Width           =   840
   End
   Begin VB.Menu mnuContextual 
      Caption         =   "Contextual"
      Visible         =   0   'False
      Begin VB.Menu mnuLighting 
         Caption         =   "&Lighting"
      End
      Begin VB.Menu mnuWireframe 
         Caption         =   "Wireframe"
      End
      Begin VB.Menu mnuAnimating 
         Caption         =   "&Animating"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'-------------------------------------------------------------------------------------------
'Author           : Paul Dahuach
'Year             : 2008
'Legal            : Do whatever you want with it, send me some feedback if you want.
'More Examples    : http://www.pauldahuach.com.ar/program_en.htm
'Dependencies     : vbGL.tlb (http://home.pacific.net.hk/~edx/tlb.htm)
'-------------------------------------------------------------------------------------------

' TGA-specific data structures
Private Type TGAHEADER
    idLength        As Byte
    colorMapType    As Byte
    imageType       As Byte
    colorMapSpec(4) As Byte
    xOrigin         As Integer
    yOrigin         As Integer
    width           As Integer
    height          As Integer
    bpp             As Byte
    imageDesc       As Byte
End Type

Private Type camera_t
    origin                      As vec3_t
    Velocity(2)                 As Single
    angles(2)                   As Single
    ViewHeight                  As Single
    MaxJumpHeight               As Single
End Type

Private Type renderCommand
    startVertex                 As Long
    vertexCount                 As Long
    texture0Idx                 As Long
    texture1Idx                 As Long
    texture2Idx                 As Long
End Type

Private vertexCount              As Long
Private Vertices()               As vec3_t
Private Normals()                As vec3_t
Private Colors()                 As vec3_t
Private tex0Coords()             As vec2_t
Private tex1Coords()             As vec2_t
Private tex2Coords()             As vec2_t
Private texture0Idx()            As Long
Private texture1Idx()            As Long
Private texture2Idx()            As Long
Private texture0Id(255)          As Long
Private texture1Id(255)          As Long
Private texture2Id(255)          As Long
Private NormalizeVectorCubeMapId As Long
Private renderCommands()         As renderCommand
Private cmdCount                 As Long
Private light_position           As vec3_t

Private camera                   As camera_t
Private Fps                      As Double
Private OldTick                  As Long
Private SystemFrame              As Long
Private wireframe                As Boolean
Private GetAsyncKeyState(255)    As Long
Private animating                As Boolean

Private blnUnload                As Boolean
Private hRC                      As Long
Private AspectRadio              As Double
Private pfd                      As PIXELFORMATDESCRIPTOR
Private iFormat                  As Long

Dim m_NormalizeVectorCubeMapImage(18431) As Byte
Private m_CgContext                      As Long
Private m_CgVertexProfile                As Long
Private m_CgFragmentProfile              As Long
Private m_CgVertexProgram                As Long
Private m_CgFragmentProgram              As Long
Private m_CgEyePositionParam             As Long
Private m_CgVertexParam_lightPosition    As Long
Private m_CgVertexParam_modelViewProj    As Long
Private m_CgFragmentParam_decal          As Long
Private m_CgFragmentParam_normalMap      As Long
Private m_CgFragmentParam_gloss          As Long
Private m_CgFragmentParam_normalizeCube  As Long
Private Const m_ProgramName              As String = "Cg Bump Map"
Private Const m_VertexProgramFileName    As String = "bump.vert.cg"
Private Const m_VertexProgramName        As String = "main"
Private Const m_FragmentProgramFileName  As String = "bump.frag.cg"
Private Const m_FragmentProgramName      As String = "main"

Private Sub Form_Load()
    Dim ff       As Integer
    Dim strChunk As String
    Dim varChunk As Variant
    Dim i        As Long
    Dim pimage   As Long
    Dim face     As Long
    
    If blnUnload Then Exit Sub
    
    pfd.nSize = Len(pfd)
    pfd.nVersion = 1
    pfd.dwFlags = PFD_DRAW_TO_WINDOW Or _
                  PFD_SUPPORT_OPENGL Or _
                  PFD_DOUBLEBUFFER
    pfd.iPixelType = PFD_TYPE_RGBA
    pfd.cColorBits = 32
    pfd.cDepthBits = 24
    pfd.cStencilBits = 8
    pfd.cAccumBits = 0
    pfd.iLayerType = PFD_MAIN_PLANE
    iFormat = ChoosePixelFormat(hDC, pfd)
    Call SetPixelFormat(hDC, iFormat, pfd)
    hRC = wglCreateContext(hDC)
    wglMakeCurrent hDC, hRC
    
    MoveWindow Me.hwnd, 0, 0, 640 + 8, 480 + 27, False
    Me.Show
    Me.Refresh
    
    glClearColor 0.1, 0.2, 0.5, 0
    glShadeModel GL_SMOOTH
    glEnable GL_DEPTH_TEST
    glDepthFunc GL_LEQUAL
    glEnable GL_CULL_FACE
    glCullFace GL_FRONT
    
    texture0Id(0) = loadTextureTGA(App.Path & "\wall_n.tga")
    texture0Id(1) = loadTextureTGA(App.Path & "\ground_n.tga")
    'texture0Id(2) = loadTextureTGA(App.Path & "\roof_n.tga")
    'texture0Id(3) = loadTextureTGA(App.Path & "\column_n.tga")
    
    texture1Id(0) = loadTextureTGA(App.Path & "\wall_d.tga")
    texture1Id(1) = loadTextureTGA(App.Path & "\ground_d.tga")
    'texture1Id(2) = loadTextureTGA(App.Path & "\roof_d.tga")
    'texture1Id(3) = loadTextureTGA(App.Path & "\column_d.tga")
    
    texture2Id(0) = loadTextureTGA(App.Path & "\wall_g.tga")
    texture2Id(1) = loadTextureTGA(App.Path & "\ground_g.tga")
    'texture2Id(2) = loadTextureTGA(App.Path & "\roof_g.tga")
    'texture2Id(3) = loadTextureTGA(App.Path & "\column_g.tga")
    
    ff = FreeFile
    Open App.Path & "\normcm_image.h" For Binary As #ff
    strChunk = Space$(LOF(ff))
    Get #ff, , strChunk
    Close #ff
    varChunk = VBA.Split(strChunk, ",")
    For i = 0 To UBound(varChunk)
        m_NormalizeVectorCubeMapImage(i) = varChunk(i)
    Next
    ' Load each 32x32 face (without mipmaps) of
    ' range-compressed "normalize vector" cube map.
    glPixelStorei GL_UNPACK_ALIGNMENT, 1
    glGenTextures 1, NormalizeVectorCubeMapId
    glBindTexture GL_TEXTURE_CUBE_MAP, NormalizeVectorCubeMapId
    For face = 0 To 5
        glTexImage2D GL_TEXTURE_CUBE_MAP_POSITIVE_X + face, 0, _
        GL_RGB8, 32, 32, 0, GL_RGB, GL_UNSIGNED_BYTE, m_NormalizeVectorCubeMapImage(pimage)
        pimage = pimage + (3 * 32 * 32)
    Next
    glTexParameteri GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR
    glTexParameteri GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE
    glTexParameteri GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE
    
    ' Load Map
    Open App.Path & "\Vertices.sng" For Binary As ff
    vertexCount = LOF(ff) / (4 * 3)
    ReDim Vertices(vertexCount - 1)
    ReDim Normals(vertexCount - 1)
    ReDim Colors(vertexCount - 1)
    ReDim tex0Coords(vertexCount - 1)
    ReDim tex1Coords(vertexCount - 1)
    ReDim tex2Coords(vertexCount - 1)
    ReDim texture0Idx(vertexCount - 1)
    ReDim texture1Idx(vertexCount - 1)
    ReDim texture2Idx(vertexCount - 1)
    ReDim renderCommands(vertexCount / 3 - 1)
    
    Get ff, , Vertices()
    Close ff
    
    Open App.Path & "\Normals.sng" For Binary As ff
    Get ff, , Normals()
    Close ff
    
    Open App.Path & "\Colors.sng" For Binary As ff
    Get ff, , Colors()
    Close ff
    
    'Texture 0 Coords
    Open App.Path & "\TexCoords.sng" For Binary As ff
    Get ff, , tex0Coords()
    Close ff
    
    Open App.Path & "\TextureId.sng" For Binary As ff
    Get ff, , texture0Idx()
    Close ff
    
    'Texture 1 Coords
    Open App.Path & "\TexCoords.sng" For Binary As ff
    Get ff, , tex1Coords()
    Close ff
    
    Open App.Path & "\TextureId.sng" For Binary As ff
    Get ff, , texture1Idx()
    Close ff
    
    'Texture 2 Coords
    Open App.Path & "\TexCoords.sng" For Binary As ff
    Get ff, , tex2Coords()
    Close ff
    
    Open App.Path & "\TextureId.sng" For Binary As ff
    Get ff, , texture2Idx()
    Close ff
    
    Dim j As Long
    renderCommands(0).texture0Idx = -1
    For i = 0 To UBound(texture0Idx)
        If renderCommands(j).texture0Idx <> texture0Idx(i) _
           Then
               j = j + 1
               renderCommands(j).startVertex = i
        End If
        renderCommands(j).texture0Idx = texture0Idx(i)
        renderCommands(j).texture1Idx = texture1Idx(i)
        renderCommands(j).texture2Idx = texture2Idx(i)
        renderCommands(j).vertexCount = renderCommands(j).vertexCount + 1
    Next
    cmdCount = j
    
    With camera
         .ViewHeight = 40
         .origin.xyz(0) = 39.24813
         .origin.xyz(1) = 40
         .origin.xyz(2) = 255.7191
         .angles(1) = -1.65
    End With
    
    Call mdlExt.InitEx
    
    animating = True
    
    Call initCg
    
    Do Until GetAsyncKeyState(vbKeyEscape) <> 0 Or blnUnload
       DoEvents
       If blnUnload Then Exit Do
       updateFps
       
       If animating Then animateLight
       moveAround
       
       glPushAttrib GL_ALL_ATTRIB_BITS
         Call Display
       glPopAttrib
       
       draw2D Fps
       
       SwapBuffers Me.hDC
    Loop
    
    cgDestroyProgram m_CgVertexProgram
    cgDestroyProgram m_CgFragmentProgram
    cgDestroyContext m_CgContext
    
    wglMakeCurrent 0, 0
    wglDeleteContext hRC
    
    End
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    'Slow, but fine for now
    GetAsyncKeyState(KeyCode) = 1
    If GetAsyncKeyState(vbKeySpace) <> 0 Then mnuAnimating_Click
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    GetAsyncKeyState(KeyCode) = 0
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = vbRightButton _
       Then
           PopupMenu Me.mnuContextual, , x, y
    End If
End Sub

Private Sub Form_Resize()
    If Me.WindowState = vbMinimized Then Exit Sub
    AspectRadio = Me.ScaleWidth / Me.ScaleHeight
    glViewport 0, 0, Me.ScaleWidth, Me.ScaleHeight
    glMatrixMode GL_PROJECTION
    glLoadIdentity
    gluPerspective 60, AspectRadio, 0.1, 10000
    glMatrixMode GL_MODELVIEW
    glLoadIdentity
End Sub

Private Sub Form_Unload(Cancel As Integer)
    blnUnload = True
End Sub

Private Sub LogToFile(texto As String)
    Dim ff As Integer
    ff = FreeFile
    Open App.Path & "\Log.txt" For Append As #ff
    Print #ff, texto
    Close #ff
End Sub

Private Sub draw2D(fpsRate As Double)
    Dim dummy   As Byte
    Dim buffer  As String
    Dim c       As Long
    glPushMatrix
      glLoadIdentity
      glMatrixMode GL_PROJECTION
      glPushMatrix
        glLoadIdentity
        glOrtho 0, 1, 1, 0, -1, 1
        glDisable GL_DEPTH_TEST
        glColor3f 1, 1, 1
        
        glRasterPos2f 1, 1
        glBitmap 0, 0, 0, 0, -50, 10, dummy
        buffer = "fps " & format$(fpsRate, "#0.0")
        For c = 1 To Len(buffer)
            glutBitmapCharacter GLUT_BITMAP_HELVETICA_10, Asc(Mid(buffer, c, 1))
        Next
        
        glEnable GL_DEPTH_TEST
      glPopMatrix
      glMatrixMode GL_MODELVIEW
    glPopMatrix
End Sub

Private Sub updateFps()
    Static maxFrames      As Long
    Static frameCount     As Long
    Static oldCount       As Currency
    Static newCount       As Currency
    Static frequency      As Currency
    Static blnStarted     As Boolean
    
    If Not blnStarted _
       Then
           maxFrames = 60
           QueryPerformanceFrequency frequency
           frameCount = 0
           Fps = 0
           blnStarted = True
    End If
    
    frameCount = frameCount + 1
    SystemFrame = GetTickCount - OldTick
    OldTick = GetTickCount
    If frameCount >= maxFrames _
       Then
           QueryPerformanceCounter newCount
           Fps = maxFrames * frequency / (newCount - oldCount)
           QueryPerformanceCounter oldCount
           frameCount = 0
    End If
End Sub

Private Function timeElapsed() As Long
    timeElapsed = SystemFrame / 10
End Function

Private Sub moveAround()
    Const StepAmount As Single = 50
    Const TurnAmount As Single = 20
    Dim PosAnt       As vec3_t
    Dim PosNew       As vec3_t
    
    PosAnt.xyz(0) = camera.origin.xyz(0)
    PosAnt.xyz(1) = camera.origin.xyz(1)
    PosAnt.xyz(2) = camera.origin.xyz(2)
    PosNew.xyz(1) = PosAnt.xyz(1)
    
    ' Walk
    If GetAsyncKeyState(vbKeyUp) <> 0 Or GetAsyncKeyState(vbKeyW) <> 0 _
       Then ' Move Forward
           camera.Velocity(2) = camera.Velocity(2) + StepAmount * timeElapsed / 10
           If camera.Velocity(2) > StepAmount _
              Then
                  camera.Velocity(2) = StepAmount
           End If
    End If
    If GetAsyncKeyState(vbKeyDown) <> 0 Or GetAsyncKeyState(vbKeyS) <> 0 _
       Then ' Move backward
           camera.Velocity(2) = camera.Velocity(2) - StepAmount * timeElapsed / 10
           If camera.Velocity(2) < -StepAmount _
              Then
                  camera.Velocity(2) = -StepAmount
           End If
    End If
    camera.Velocity(2) = camera.Velocity(2) * 0.55
    PosNew.xyz(0) = PosAnt.xyz(0) + Cos(camera.angles(1)) * camera.Velocity(2)
    PosNew.xyz(2) = PosAnt.xyz(2) + Sin(camera.angles(1)) * camera.Velocity(2)

    'Girar
    If GetAsyncKeyState(vbKeyLeft) <> 0 Or GetAsyncKeyState(vbKeyA) <> 0 _
       Then ' Turn Left
           camera.Velocity(1) = camera.Velocity(1) - 1 * timeElapsed / TurnAmount
           If camera.Velocity(1) < -TurnAmount _
              Then
                  camera.Velocity(1) = -TurnAmount
           End If
    End If
    If GetAsyncKeyState(vbKeyRight) <> 0 Or GetAsyncKeyState(vbKeyD) <> 0 _
       Then ' Turn Right
           camera.Velocity(1) = camera.Velocity(1) + 1 * timeElapsed / TurnAmount
           If camera.Velocity(1) > TurnAmount _
              Then
                  camera.Velocity(1) = TurnAmount
           End If
    End If
    camera.Velocity(1) = camera.Velocity(1) * 0.5
    camera.angles(1) = camera.angles(1) + camera.Velocity(1)

    'Look up/down
    If GetAsyncKeyState(vbKeyQ) <> 0 _
       Then 'Look up
           camera.Velocity(0) = camera.Velocity(0) + 0.75 * timeElapsed / 12
           If camera.angles(0) > 1.5 _
              Then
                  camera.angles(0) = 1.5
           End If
    End If
    If GetAsyncKeyState(vbKeyZ) <> 0 _
       Then 'Look Down
           camera.Velocity(0) = camera.Velocity(0) - 0.75 * timeElapsed / 12
           If camera.angles(0) < -1.5 _
              Then
                  camera.angles(0) = -1.5
           End If
    End If
    camera.Velocity(0) = camera.Velocity(0) * 0.5
    camera.angles(0) = camera.angles(0) + camera.Velocity(0)
    
    If GetAsyncKeyState(vbKeySubtract) <> 0 _
       Then ' Fly
           PosNew.xyz(1) = PosAnt.xyz(1) + timeElapsed * 1.5
    End If
    If GetAsyncKeyState(vbKeyAdd) <> 0 _
       Then ' Land
           PosNew.xyz(1) = PosAnt.xyz(1) - timeElapsed * 1.5
    End If
    If GetAsyncKeyState(vbKeyX) <> 0 _
       Then ' On your knees
           camera.ViewHeight = 20
       Else
           camera.ViewHeight = 40
    End If
    camera.origin = PosNew
    
    'Set the camera origin and look at point
    glMatrixMode GL_PROJECTION
    glLoadIdentity
    gluPerspective 60, AspectRadio, 0.1, 10000
    gluLookAt camera.origin.xyz(0), _
              camera.origin.xyz(1), _
              camera.origin.xyz(2), _
              camera.origin.xyz(0) + Cos(camera.angles(1)), _
              camera.origin.xyz(1) + Sin(camera.angles(0)), _
              camera.origin.xyz(2) + Sin(camera.angles(1)), 0, 1, 0
    glMatrixMode GL_MODELVIEW

End Sub

Private Sub mnuAnimating_Click()
    If Me.mnuAnimating.Checked _
       Then
           Me.mnuAnimating.Checked = False
       Else
           Me.mnuAnimating.Checked = True
    End If
    animating = Me.mnuAnimating.Checked
End Sub

Private Sub mnuLighting_Click()
    If Me.mnuLighting.Checked _
       Then
           Me.mnuLighting.Checked = False
           glDisable GL_LIGHTING
       Else
           Me.mnuLighting.Checked = True
           glEnable GL_LIGHTING
    End If
End Sub

Private Sub mnuWireframe_Click()
    If Me.mnuWireframe.Checked _
       Then
           Me.mnuWireframe.Checked = False
           glPolygonMode GL_FRONT_AND_BACK, GL_FILL
       Else
           Me.mnuWireframe.Checked = True
           glPolygonMode GL_FRONT_AND_BACK, GL_LINE
    End If
End Sub

Function loadTextureTGA(filename As String) As Long
    ' Loads a Targa, extracts the data from it, and places it in a texture
    ' object associated with textureID.
    On Error GoTo Hell
    
    Const TGA_NODATA                As Byte = 0
    Const TGA_INDEXEDED             As Byte = 1
    Const TGA_RGB                   As Byte = 2
    Const TGA_GRAYSCALE             As Byte = 3
    Const TGA_INDEXED_RLE           As Byte = 9
    Const TGA_RGB_RLE               As Byte = 10
    Const TGA_GRAYSCALE_RLE         As Byte = 11
    
    Const GL_TEXTURE0               As Long = &H84C0&
    Const GL_TEXTURE1               As Long = &H84C1&
    Const GL_COMPRESSED_RGB_ARB     As Long = &H84ED&
    Const GL_COMPRESSED_RGBA_ARB    As Long = &H84EE&
    
    Dim textureId       As Long
    Dim pFile           As Integer
    Dim tga             As TGAHEADER
    Dim colorMode       As Long
    Dim imageSize       As Long
    Dim pData()         As Byte
    Dim dataFormat      As Long
    Dim internalformat  As Long
    Dim lngRet          As Long
    
    ' open the TGA file
    pFile = FreeFile
    
    If Dir(filename) = vbNullString _
       Then
           LogToFile "Texture Lost: " & filename
           Exit Function
    End If
    
    Open filename For Binary As #pFile
    
    ' read in the image type
    Get #pFile, , tga
    
    ' see if the type is one that we support
    If (tga.imageType <> TGA_RGB) And _
       (tga.imageType <> TGA_GRAYSCALE) _
       Then
           Close #pFile
           Exit Function
    End If
    
    ' if colorMode is 3, there is no alpha channel
    colorMode = tga.bpp / 8
    imageSize = tga.width
    imageSize = imageSize * tga.height
    imageSize = imageSize * colorMode
    
    ReDim pData(imageSize - 1)
    
    ' read image data
    Get #pFile, , pData
      
    ' close the file
    Close #pFile
    
    ' choose the proper data formats depending on whether or not there's an
    ' alpha channel
    
    dataFormat = IIf(colorMode = 3, GL_BGR_EXT, GL_BGRA_EXT)
    
    If colorMode = 3 _
       Then
           internalformat = GL_COMPRESSED_RGB_ARB
           'internalformat = GL_RGB
       Else
           internalformat = GL_COMPRESSED_RGBA_ARB
           'internalformat = GL_RGBA
    End If
    
    glGenTextures 1, textureId
    glBindTexture GL_TEXTURE_2D, textureId
    
    glPixelTransferf GL_RED_SCALE, 1
    glPixelTransferf GL_GREEN_SCALE, 1
    glPixelTransferf GL_BLUE_SCALE, 1
    
    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT
    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT

    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR
    glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR
    
    lngRet = gluBuild2DMipmaps(GL_TEXTURE_2D, internalformat, tga.width, tga.height, dataFormat, GL_UNSIGNED_BYTE, VarPtr(pData(0)))
    If lngRet <> 0 _
       Then
           LogToFile "Error gluBuild2DMipmaps"
    End If
    Erase pData
    If glIsTexture(textureId) _
       Then
           loadTextureTGA = textureId
    End If
    
    Exit Function
Hell:
    LogToFile "LoadTextureTGA(" & filename & "): " & err.Description
End Function

Private Sub initCg()
    m_CgContext = cgCreateContext()
    cgGLSetDebugMode CG_FALSE
    
    m_CgVertexProfile = cgGLGetLatestProfile(CG_GL_VERTEX)
    cgGLSetOptimalOptions m_CgVertexProfile
    
    m_CgVertexProgram = _
      cgCreateProgramFromFile( _
        m_CgContext, _
        CG_SOURCE, _
        m_VertexProgramFileName, _
        m_CgVertexProfile, _
        m_VertexProgramName, _
        vbNullString)
    
    cgGLLoadProgram m_CgVertexProgram
    
    m_CgEyePositionParam = cgGetNamedParameter(m_CgVertexProgram, "eyePosition")
    If m_CgEyePositionParam = 0 _
       Then
           LogToFile m_ProgramName & ": must find parameter named EyePosition"
           End
    End If
    m_CgVertexParam_lightPosition = cgGetNamedParameter(m_CgVertexProgram, "lightPosition")
    m_CgVertexParam_modelViewProj = cgGetNamedParameter(m_CgVertexProgram, "modelViewProj")
    
    m_CgFragmentProfile = cgGLGetLatestProfile(CG_GL_FRAGMENT)
    cgGLSetOptimalOptions m_CgFragmentProfile

    m_CgFragmentProgram = _
      cgCreateProgramFromFile( _
        m_CgContext, _
        CG_SOURCE, _
        m_FragmentProgramFileName, _
        m_CgFragmentProfile, _
        m_FragmentProgramName, _
        vbNullString)
    
    cgGLLoadProgram m_CgFragmentProgram
    
    m_CgFragmentParam_decal = cgGetNamedParameter(m_CgFragmentProgram, "decal")
    m_CgFragmentParam_normalMap = cgGetNamedParameter(m_CgFragmentProgram, "normalMap")
    m_CgFragmentParam_gloss = cgGetNamedParameter(m_CgFragmentProgram, "gloss")
    m_CgFragmentParam_normalizeCube = cgGetNamedParameter(m_CgFragmentProgram, "normalizeCube")
    
    cgGLSetTextureParameter m_CgFragmentParam_normalizeCube, NormalizeVectorCubeMapId
    checkForCgError "init"
End Sub

Public Sub checkForCgError(situation As String)
    Dim lngCGerror As Long
    Dim lpszError  As Long
    lngCGerror = cgGetError
    If lngCGerror <> CG_NO_ERROR _
       Then
           LogToFile situation & ": " & lpszError
           If lngCGerror = CG_COMPILER_ERROR _
              Then
                  LogToFile cgGetLastListing(m_CgContext)
           End If
           End
    End If
End Sub


Private Sub animateLight()
    Const Radius         As Single = 108
    Const ElevationRange As Single = 100
    Dim eyePosition(2)   As Single
    Static m_Angle       As Single
    
    m_Angle = m_Angle + 0.01
    If m_Angle > 2 * 3.14159 _
       Then
           m_Angle = m_Angle - 2 * 3.14159
    End If
    light_position.xyz(0) = 0 + Radius * Sin(m_Angle)
    light_position.xyz(1) = ElevationRange + Sin(m_Angle)
    light_position.xyz(2) = 100 + Radius * Cos(m_Angle)

    Exit Sub
    Static Positive(3) As Boolean
    
    If light_position.xyz(0) > 600 Or _
       light_position.xyz(0) < 100 _
       Then
           Positive(0) = Not Positive(0)
    End If
    If light_position.xyz(1) > 600 Or _
       light_position.xyz(1) < 100 _
       Then
           Positive(1) = Not Positive(1)
    End If
    If light_position.xyz(2) > 100 Or _
       light_position.xyz(2) < -800 _
       Then
           Positive(2) = Not Positive(2)
    End If
    light_position.xyz(0) = light_position.xyz(0) + Rnd * 8 * IIf(Positive(0), 1, -1)
    light_position.xyz(1) = light_position.xyz(1) + Rnd * 8 * IIf(Positive(1), 1, -1)
    light_position.xyz(2) = light_position.xyz(2) + Rnd * 8 * IIf(Positive(2), 1, -1)
End Sub

Private Sub Display()
    
    Dim i As Long
    glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
    glLoadIdentity
    
    cgGLBindProgram m_CgVertexProgram
    cgGLSetStateMatrixParameter m_CgVertexParam_modelViewProj, _
                                CG_GL_MODELVIEW_PROJECTION_MATRIX, _
                                CG_GL_MATRIX_IDENTITY
    cgSetParameter3fv m_CgVertexParam_lightPosition, light_position.xyz(0)
    cgSetParameter3fv m_CgEyePositionParam, camera.origin.xyz(0)
    
    'Texture 0 Unit
    glTexCoordPointer 2, GL_FLOAT, 8, tex0Coords(0).st(0)
    glEnableClientState GL_TEXTURE_COORD_ARRAY
    
    If vertexCount > 0 _
       Then
           glEnableClientState GL_VERTEX_ARRAY
           glVertexPointer 3, GL_FLOAT, 0, Vertices(0).xyz(0)
           glEnableClientState GL_NORMAL_ARRAY
           glNormalPointer GL_FLOAT, 0, Normals(0).xyz(0)
           glEnableClientState GL_COLOR_ARRAY
           glColorPointer 3, GL_FLOAT, 12, Colors(0).xyz(0)
           For i = 1 To cmdCount
               cgGLSetTextureParameter m_CgFragmentParam_normalMap, texture0Id(renderCommands(i).texture0Idx)
               cgGLSetTextureParameter m_CgFragmentParam_decal, texture1Id(renderCommands(i).texture1Idx)
               cgGLSetTextureParameter m_CgFragmentParam_gloss, texture2Id(renderCommands(i).texture2Idx)
               cgGLEnableProfile m_CgVertexProfile
               cgGLBindProgram m_CgFragmentProgram
               cgGLEnableTextureParameter m_CgFragmentParam_normalMap
               cgGLEnableTextureParameter m_CgFragmentParam_gloss
               cgGLEnableTextureParameter m_CgFragmentParam_normalizeCube
               cgGLEnableTextureParameter m_CgFragmentParam_decal
               cgGLEnableProfile m_CgFragmentProfile
               
               glDrawArrays GL_TRIANGLES, renderCommands(i).startVertex, renderCommands(i).vertexCount
               
               cgGLDisableProfile m_CgVertexProfile
               cgGLDisableProfile m_CgFragmentProfile
           Next
           glDisableClientState GL_VERTEX_ARRAY
           glDisableClientState GL_NORMAL_ARRAY
           glDisableClientState GL_COLOR_ARRAY
    End If
    
    'Texture 0 Unit
    glDisableClientState GL_TEXTURE_COORD_ARRAY
    glDisable GL_TEXTURE_2D
    
    ' Render light as white ball using fixed function pipe
    glColor4f 1, 1, 1, 0.5
    glTranslatef light_position.xyz(0), light_position.xyz(1), light_position.xyz(2)
    glutSolidSphere 10, 12, 12

End Sub

Private Function compute_plane(a As vec3_t, b As vec3_t, c As vec3_t) As vec4_t
    Dim p  As vec4_t
    Dim v0 As vec3_t
    v0.xyz(0) = b.xyz(0) - a.xyz(0)
    v0.xyz(1) = b.xyz(1) - a.xyz(1)
    v0.xyz(2) = b.xyz(2) - a.xyz(2)
    Dim v1 As vec3_t
    v1.xyz(0) = c.xyz(0) - a.xyz(0)
    v1.xyz(1) = c.xyz(1) - a.xyz(1)
    v1.xyz(2) = c.xyz(2) - a.xyz(2)
    Dim cr As vec3_t
    cr.xyz(0) = v0.xyz(1) * v1.xyz(2) - v0.xyz(2) * v1.xyz(1)
    cr.xyz(1) = v0.xyz(2) * v1.xyz(0) - v0.xyz(0) * v1.xyz(2)
    cr.xyz(2) = v0.xyz(0) * v1.xyz(1) - v0.xyz(1) * v1.xyz(0)
    Dim l As Single
    l = Sqr(cr.xyz(0) * cr.xyz(0) + cr.xyz(1) * cr.xyz(1) + cr.xyz(2) * cr.xyz(2))
    If l = 0 _
       Then ' degenerate triangle
            p.xyzw(0) = 0
            p.xyzw(1) = 0
            p.xyzw(2) = 0
            p.xyzw(3) = 0
            compute_plane = p
            Exit Function
    End If
    p.xyzw(0) = cr.xyz(0) / l
    p.xyzw(1) = cr.xyz(1) / l
    p.xyzw(2) = cr.xyz(2) / l
    
    p.xyzw(3) = -(p.xyzw(0) * a.xyz(0) + p.xyzw(1) * a.xyz(1) + p.xyzw(2) * a.xyz(2)) ' signed distance of a point on the plane from the origin
    
    compute_plane = p

End Function

